diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
index 349b7a37f..27b6fe239 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLever.java
@@ -2,6 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -17,7 +20,7 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicLever extends BlockLogic
+public class BlockLogicLever extends BlockLogic implements ISupportable
 {
     public static final int MASK_POWERED = 0b0001_0000;
     public static final int MASK_ROTATION = 0b0000_1111;
@@ -53,22 +56,27 @@ public class BlockLogicLever extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean canPlaceBlockOnSide(World world, int x, int y, int z, Side side) {
         Side checkSide = side.getOpposite();
-        return world.isBlockNormalCube(x + checkSide.getOffsetX(), y + checkSide.getOffsetY(), z + checkSide.getOffsetZ());
+        return isSupported(world, x, y, z, checkSide);
     }
 
 
     @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
+    public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        for (Side s : Side.sides){
-            if(world.isBlockNormalCube(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ())){
-                return true;
-            }
-        }
-        return false;
+        return isSupported(world, x, y, z, Side.BOTTOM)
+            || isSupported(world, x, y, z, Side.TOP)
+            || isSupported(world, x, y, z, Side.NORTH)
+            || isSupported(world, x, y, z, Side.SOUTH)
+            || isSupported(world, x, y, z, Side.WEST)
+            || isSupported(world, x, y, z, Side.EAST);
     }
     
     @Override
@@ -78,33 +86,33 @@ public class BlockLogicLever extends BlockLogic
         int rotation = -1;
         switch (side){
             case BOTTOM:
-                if (world.canPlaceOnSurfaceOfBlock(x, y + 1, z)){
+                if (isSupported(world, x, y, z, Side.TOP)){
                     rotation = ROTATION_BOTTOM_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
                 }
                 break;
             case TOP:
-                if (world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
+                if (isSupported(world, x, y, z, Side.BOTTOM))
                 {
                     rotation = ROTATION_TOP_NS + (mob.getHorizontalPlacementDirection(side).getAxis() == Axis.Z ? 1 : 0);
                 }
                 break;
             case NORTH:
-                if (world.isBlockNormalCube(x, y, z + 1)){
+                if (isSupported(world, x, y, z, Side.SOUTH)){
                     rotation = ROTATION_NORTH;
                 }
                 break;
             case SOUTH:
-                if (world.isBlockNormalCube(x, y, z - 1)){
+                if (isSupported(world, x, y, z, Side.NORTH)){
                     rotation = ROTATION_SOUTH;
                 }
                 break;
             case WEST:
-                if (world.isBlockNormalCube(x + 1, y, z)){
+                if (isSupported(world, x, y, z, Side.EAST)){
                     rotation = ROTATION_WEST;
                 }
                 break;
             case EAST:
-                if (world.isBlockNormalCube(x - 1, y, z)){
+                if (isSupported(world, x, y, z, Side.WEST)){
                     rotation = ROTATION_EAST;
                 }
                 break;
@@ -125,33 +133,33 @@ public class BlockLogicLever extends BlockLogic
         int rotation = -1;
         switch (side.getOpposite()){
             case BOTTOM:
-                if (world.canPlaceOnSurfaceOfBlock(x, y + 1, z)){
+                if (isSupported(world, x, y, z, Side.TOP)){
                     rotation = ROTATION_BOTTOM_NS;
                 }
                 break;
             case TOP:
-                if (world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
+                if (isSupported(world, x, y, z, Side.BOTTOM))
                 {
                     rotation = ROTATION_TOP_NS;
                 }
                 break;
             case NORTH:
-                if (world.isBlockNormalCube(x, y, z + 1)){
+                if (isSupported(world, x, y, z, Side.SOUTH)){
                     rotation = ROTATION_NORTH;
                 }
                 break;
             case SOUTH:
-                if (world.isBlockNormalCube(x, y, z - 1)){
+                if (isSupported(world, x, y, z, Side.NORTH)){
                     rotation = ROTATION_SOUTH;
                 }
                 break;
             case WEST:
-                if (world.isBlockNormalCube(x + 1, y, z)){
+                if (isSupported(world, x, y, z, Side.EAST)){
                     rotation = ROTATION_WEST;
                 }
                 break;
             case EAST:
-                if (world.isBlockNormalCube(x - 1, y, z)){
+                if (isSupported(world, x, y, z, Side.WEST)){
                     rotation = ROTATION_EAST;
                 }
                 break;
@@ -174,24 +182,24 @@ public class BlockLogicLever extends BlockLogic
             boolean shouldBreak;
             switch (rotation){
                 case ROTATION_EAST:
-                    shouldBreak = !world.isBlockNormalCube(x - 1, y, z);
+                    shouldBreak = !isSupported(world, x, y, z, Side.WEST);
                     break;
                 case ROTATION_WEST:
-                    shouldBreak = !world.isBlockNormalCube(x + 1, y, z);
+                    shouldBreak = !isSupported(world, x, y, z, Side.EAST);
                     break;
                 case ROTATION_SOUTH:
-                    shouldBreak = !world.isBlockNormalCube(x, y, z - 1);
+                    shouldBreak = !isSupported(world, x, y, z, Side.NORTH);
                     break;
                 case ROTATION_NORTH:
-                    shouldBreak = !world.isBlockNormalCube(x, y, z + 1);
+                    shouldBreak = !isSupported(world, x, y, z, Side.SOUTH);
                     break;
                 case ROTATION_TOP_NS:
                 case ROTATION_TOP_WE:
-                    shouldBreak = !world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+                    shouldBreak = !isSupported(world, x, y, z, Side.BOTTOM);
                     break;
                 case ROTATION_BOTTOM_NS:
                 case ROTATION_BOTTOM_WE:
-                    shouldBreak = !world.canPlaceOnSurfaceOfBlock(x, y + 1, z);
+                    shouldBreak = !isSupported(world, x, y, z, Side.TOP);
                     break;
                 default:
                     shouldBreak = false;
@@ -359,4 +367,9 @@ public class BlockLogicLever extends BlockLogic
     {
         return true;
     }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE.center();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index 4ecea2b67..000b76589 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -7,7 +7,6 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Axis;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -28,7 +27,7 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         updateState(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
index f85515d06..6f793173f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMoss.java
@@ -8,7 +8,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -26,7 +25,7 @@ public class BlockLogicMoss extends BlockLogic implements IBonemealable {
 	}
 
 	@Override
-	public void updateTick(World world, int x, int y, int z, Random rand) {
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
 		if (world.isClientSide) {
 			return;
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
index ac2356d97..8043cad7e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
@@ -149,7 +149,7 @@ public class BlockLogicMud extends BlockLogic {
 
 
     @Override
-    public void updateTick(final World world, final int x, final int y, final int z, final Random rand)
+    public void updateTick(final World world, final int x, final int y, final int z, final Random rand, boolean isRandomTick)
     {
         // hydrate mud
         if(isHardened) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
index c6832f164..1f3fe7550 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMushroom.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -21,7 +20,7 @@ public class BlockLogicMushroom extends BlockLogicFlower
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(rand.nextInt(25) == 0)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
index 1ab71f573..f6f2aca92 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNetherrackIgneous.java
@@ -59,7 +59,7 @@ public class BlockLogicNetherrackIgneous extends BlockLogic {
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         if (canMelt(world, x, y, z)) {
             world.setBlockWithNotify(x, y, z, Blocks.FLUID_LAVA_FLOWING.id());
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index bee8f2431..3e73e4728 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -12,7 +12,6 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.generate.feature.WorldFeatureOre;
 import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
@@ -77,7 +76,7 @@ public class BlockLogicOreRedstone extends BlockLogic
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(illuminated)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
index 4ecb2bf6d..9b835e7a3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
@@ -2,12 +2,17 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockLogicOverlayPebbles extends BlockLogic
 {
@@ -17,6 +22,17 @@ public class BlockLogicOverlayPebbles extends BlockLogic
         setBlockBounds(0, 0, 0, 1, 0.0625F, 1);
     }
 
+    public static boolean canSpawnOn(final @Nullable Block<?> block) {
+        return
+            block == Blocks.GRASS ||
+                block == Blocks.SAND ||
+                block == Blocks.DIRT ||
+                block == Blocks.SANDSTONE ||
+                block == Blocks.DIRT_SCORCHED ||
+                block == Blocks.DIRT_SCORCHED_RICH ||
+                block == Blocks.GRASS_SCORCHED;
+    }
+
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
@@ -58,6 +74,11 @@ public class BlockLogicOverlayPebbles extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index 6de96e93e..eb73cc6e7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.enums.EnumDropCause;
@@ -9,10 +11,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -74,6 +78,11 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     public int[] getPortalDims(World world, int x, int y, int z, boolean expectMiddle)
     {
     	return getPortalDims(world, x, y, z, false, expectMiddle);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index a16cb0c84..536352f35 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -1,13 +1,15 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -16,7 +18,7 @@ import org.jetbrains.annotations.NotNull;
 import java.util.List;
 import java.util.Random;
 
-public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implements IPaintable
+public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implements IPaintable, ISupportable
 {
     public static final int MASK_POWERED = 0b0000_0001;
     public static final int MASK_SIDE = 0b0000_1110;
@@ -56,29 +58,40 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-	public boolean canPlaceBlockAt(World world, int x, int y, int z)
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
+    @Override
+    public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z) ||
-            world.isBlockNormalCube(x, y + 1, z) ||
-            world.isBlockNormalCube(x + 1, y, z) ||
-            world.isBlockNormalCube(x - 1, y, z) ||
-            world.isBlockNormalCube(x, y, z + 1) ||
-            world.isBlockNormalCube(x, y, z - 1);
+        return isSupported(world, x, y, z, Side.BOTTOM)
+            || isSupported(world, x, y, z, Side.TOP)
+            || isSupported(world, x, y, z, Side.NORTH)
+            || isSupported(world, x, y, z, Side.SOUTH)
+            || isSupported(world, x, y, z, Side.WEST)
+            || isSupported(world, x, y, z, Side.EAST);
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        boolean flag = !canPlaceBlockAt(world, x, y, z);
-        if(flag)
-        {
+        if(!isSupported(world, x, y, z, sideFromMeta(world.getBlockMetadata(x, y, z)))) {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
         }
     }
 
+    private Side getDefaultSide(World world, int x, int y, int z) {
+        for (int i = 0; i < Side.sides.length; i++) {
+            Side side = Side.sides[i];
+            if (isSupported(world, x, y, z, side)) return side;
+        }
+        return Side.NONE;
+    }
+
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isClientSide)
         {
@@ -119,13 +132,10 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
             default: list = world.getEntitiesWithinAABB(triggerMobClass, AABB.fromPool(1 - (isPressed ? pixel/2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).move(x, y, z)); break;
         }
 
-        if(list != null)
-        {
-            for (int i = 0; i < list.size(); i++) {
-                if (list.get(i).canInteract()) {
-                    isSteppedOn = true;
-                    break;
-                }
+        for (int i = 0; i < list.size(); i++) {
+            if (list.get(i).canInteract()) {
+                isSteppedOn = true;
+                break;
             }
         }
         if(isSteppedOn && !isPressed)
@@ -221,12 +231,18 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        int meta = world.getBlockMetadata(x, y, z);
         side = side.getOpposite();
-        if (world.isBlockNormalCube(x + side.getOffsetX(), y + side.getOffsetY(), z + side.getOffsetZ())) {
-            world.setBlockMetadata(x, y, z, setSide(world.getBlockMetadata(x, y, z), side));
-        } else if (world.canPlaceOnSurfaceOfBlock(x, y - 1, z)) {
-            world.setBlockMetadata(x, y, z, setSide(world.getBlockMetadata(x, y, z), Side.BOTTOM));
+        if (!isSupported(world, x, y, z, side)) {
+            side = getDefaultSide(world, x, y, z);
+        }
+        if (side != Side.NONE) {
+            world.setBlockMetadata(x, y, z, setSide(meta, side));
+        } else {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
+            world.setBlockWithNotify(x, y, z, 0);
         }
+
     }
 
     @Override
@@ -244,4 +260,9 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
             world.scheduleBlockUpdate(x, y, z, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.id(), tickDelay());
         }
     }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE.center();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index cb611e085..223eabee6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -2,12 +2,16 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.logic.RailDirection;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkPosition;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -67,6 +71,11 @@ public class BlockLogicRail extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z) {
         return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index fa4ede3d8..d025a2480 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -40,7 +40,7 @@ public class BlockLogicRailDetector extends BlockLogicRail {
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand) {
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         if(world.isClientSide) {
             return;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index 3eff1421b..24981746a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -3,6 +3,8 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -46,6 +48,11 @@ public class BlockLogicRepeater extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
@@ -77,7 +84,7 @@ public class BlockLogicRepeater extends BlockLogic
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand) {
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
         int meta = world.getBlockMetadata(x, y, z);
         boolean flag = isGettingPower(world, x, y, z, meta);
         if(isRepeaterPowered && !flag) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index ce16bbeec..b81f01b3a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -2,6 +2,8 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.EnumDropCause;
@@ -12,6 +14,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicRope
     extends BlockLogic {
@@ -30,6 +33,11 @@ public class BlockLogicRope
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean isClimbable(World world, int x, int y, int z) {
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
index df35ba8a5..d24012e0b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSand.java
@@ -1,13 +1,9 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
-import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
@@ -32,7 +28,7 @@ public class BlockLogicSand extends BlockLogic
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         tryToFall(world, x, y, z);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index e90f16de9..ce4299990 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -28,7 +28,7 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isClientSide)
         {
@@ -41,7 +41,7 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
             }	
         }
 
-        super.updateTick(world, x, y, z, rand);
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         int growthRate = 30;
         if(world.getSeasonManager().getCurrentSeason() != null){
             growthRate = MathHelper.floor_float(growthRate / world.getSeasonManager().getCurrentSeason().cropGrowthFactor);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
index 0ec3595da..944aa8e74 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingPine.java
@@ -16,13 +16,13 @@ public class BlockLogicSaplingPine extends BlockLogicSaplingBase
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isClientSide)
         {
             return;
         }
-        super.updateTick(world, x, y, z, rand);
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         int growthRate = 30;
         if(world.getBlockLightValue(x, y + 1, z) >= 9 && rand.nextInt(growthRate) == 0)
         {
